import * as i0 from '@angular/core';
import { ElementRef, Injectable, Component, ViewChild, Input, NgModule } from '@angular/core';
import * as Prism from 'prismjs';
import 'prismjs/plugins/normalize-whitespace/prism-normalize-whitespace';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';

class AsPrismService {
    /**
     * @param {ElementRef} el - HTMLELement
     * @param {AsPrismOptions} [options] - Highligher Option
     */
    highlightElement(el, options) {
        if (el instanceof ElementRef) {
            Prism.highlightElement(el.nativeElement, options?.async, options?.callback);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismService, decorators: [{
            type: Injectable
        }] });

class AsPrismComponent {
    constructor(prismService) {
        this.prismService = prismService;
        this.language = 'json';
    }
    ngAfterViewInit() {
        this.prismService.highlightElement(this.codeEle);
    }
    ngOnChanges(changes) {
        if (changes?.code) {
            if (this.codeEle?.nativeElement) {
                this.codeEle.nativeElement.textContent = this.code;
                this.prismService.highlightElement(this.codeEle);
            }
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismComponent, deps: [{ token: AsPrismService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.5", type: AsPrismComponent, selector: "as-prism", inputs: { code: "code", language: "language" }, viewQueries: [{ propertyName: "codeEle", first: true, predicate: ["codeEle"], descendants: true }], usesOnChanges: true, ngImport: i0, template: `
    <pre *ngIf="language" [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
  `, isInline: true, dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'as-prism',
                    template: `
    <pre *ngIf="language" [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
  `
                }]
        }], ctorParameters: function () { return [{ type: AsPrismService }]; }, propDecorators: { codeEle: [{
                type: ViewChild,
                args: ['codeEle']
            }], code: [{
                type: Input
            }], language: [{
                type: Input
            }] } });

class AsPrismModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, declarations: [AsPrismComponent], imports: [CommonModule], exports: [AsPrismComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, providers: [AsPrismService], imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.5", ngImport: i0, type: AsPrismModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [AsPrismComponent],
                    imports: [CommonModule],
                    exports: [AsPrismComponent],
                    providers: [AsPrismService]
                }]
        }] });

/*
 * Public API Surface of as-prism
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AsPrismComponent, AsPrismModule, AsPrismService };
//# sourceMappingURL=as-prism.mjs.map
